#include <WiFi.h>
#include <SPI.h>
#include <LoRa.h>
#include <WiFiMulti.h>

#define led 5
WiFiMulti WiFiMulti;
WiFiClient  client;
const char* ssid     = "NOA Labs (2.4GHz)"; // Your SSID
const char* password = "noa-labs.com"; // WiFi password

char incoming;
char str[50];
uint8_t num=0;
const char* host = "api.thingspeak.com";
String api_key = "RDD4L1JM49N99QHK"; // copy and paste the API Write Key provied by ThingSpeak Environment Sensor Data1

unsigned short check_sum;

void setup() {
  Serial.begin(115200);
  while (!Serial);
  pinMode(led,OUTPUT);
  Serial.println("LoRa Receiver");
  WiFi.mode(WIFI_STA);
  connectToWifi();
  if (!LoRa.begin(433E6)) {
    Serial.println("Starting LoRa failed!");
    while (1);
  }
}

void loop() {

    // try to parse packet
  int packetSize = LoRa.parsePacket();
  if (packetSize) {
    // received a packet
    Serial.print("Received packet '");
    digitalWrite(led,HIGH);
    // read packet
    while (LoRa.available()) {
      incoming=(char)LoRa.read();
      Serial.print(incoming);
      str[num++]=incoming;
    }

    // print RSSI of packet
    Serial.print("' with RSSI ");
    Serial.println(LoRa.packetRssi());
    Send_Data();
    num=0;
  }
  else
  {digitalWrite(led,LOW);}
}

void connectToWifi()
{
  // connection to a WiFi network
  WiFiMulti.addAP(ssid, password);

  Serial.println();
  Serial.println();
  Serial.print("Wait for WiFi... ");

  while (WiFiMulti.run() != WL_CONNECTED) {
    Serial.print(".");
    delay(100);
    }

  Serial.println("");
  Serial.println("WiFi connected");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
 }
 
void Send_Data()
{
  // Use WiFiClient class to create TCP connections
  WiFiClient client;

  const int httpPort = 80;

  if (!client.connect(host, httpPort)) {
    Serial.println("connection failed");
    return;
  }
  else
  {
    String data_to_send = api_key;
    data_to_send += str;

    data_to_send += "\r\n\r\n";

    client.print("POST /update HTTP/1.1\n");
    client.print("Host: api.thingspeak.com\n");
    client.print("Connection: close\n");
    client.print("X-THINGSPEAKAPIKEY: " + api_key + "\n");
    client.print("Content-Type: application/x-www-form-urlencoded\n");
    client.print("Content-Length: ");
    client.print(data_to_send.length());
    client.print("\n\n");
    client.print(data_to_send);
    digitalWrite(led,HIGH);
    delay(100);
    digitalWrite(led,LOW);
    delay(1000);
  }

  client.stop();

}
